︠e427c70b-53f6-4555-a8fd-6e4bde84901d︠
︡1864a58c-fe30-4cdd-b2a5-05bff5a506ab︡
︠27c445b5-3bb0-4c75-8d08-dff320983d5fi︠
%html
<h1 style="font-size: 2em;">Algebraic Structures using SageMath&nbsp;</h1>
<p><strong><em><a title="Applied Discrete Structures" href=" http://faculty.uml.edu/klevasseur/ads2" target="_blank">Applied Discrete Structures</a>&nbsp;</em>by Alan Doerr &amp; Kenneth Levasseur is licensed under a Creative Commons Attribution - Noncommercial - &nbsp;No Derivative Works 3.0 United States License.</strong></p>
<p>
</p>
︡aaa2603f-9386-409a-9d15-80975d73bcc1︡{"done":true,"html":"<h1 style=\"font-size: 2em;\">Algebraic Structures using SageMath&nbsp;</h1>\n<p><strong><em><a title=\"Applied Discrete Structures\" href=\" http://faculty.uml.edu/klevasseur/ads2\" target=\"_blank\">Applied Discrete Structures</a>&nbsp;</em>by Alan Doerr &amp; Kenneth Levasseur is licensed under a Creative Commons Attribution - Noncommercial - &nbsp;No Derivative Works 3.0 United States License.</strong></p>\n<p>\n</p>"}
︠d386ba81-b874-409c-90c8-9484c99924b4s︠
import sage.monoids.monoid
︡dfb39ad1-2587-4afc-9116-f1f0c5ab86fe︡{"done":true}
︠2e3ea86e-966c-4548-bb60-147a8b585126s︠

︡6b15b099-b620-4368-8bd7-261254cbe6df︡{"done":true}
︠4ae0acfd-618f-49a8-9fae-5893af389e96s︠
M=Monoids().free(['a','b'])
︡3835c207-872b-4ca6-81a9-1917467d7577︡{"done":true}
︠056a4f26-12ef-4e46-828a-f8b9eea90ce0s︠
x=M('ab')
︡ff95eaee-697d-43e3-a133-35a29334b146︡{"done":true}
︠d732a2d8-cb99-4147-9ea7-4d8829d03b09s︠
x
︡89798249-ecb7-4749-a0e8-4d253feaf16d︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python3.8/site-packages/smc_sagews/sage_server.py\", line 1230, in execute\n    exec(\n  File \"\", line 1, in <module>\n  File \"/cocalc/lib/python3.8/site-packages/smc_sagews/sage_salvus.py\", line 4013, in displayhook\n    _system_sys_displayhook(obj)\n  File \"sage/structure/sage_object.pyx\", line 194, in sage.structure.sage_object.SageObject.__repr__ (build/cythonized/sage/structure/sage_object.c:2460)\n    result = reprfunc()\n  File \"/ext/sage/sage-9.2/local/lib/python3.8/site-packages/sage/monoids/indexed_free_monoid.py\", line 115, in _repr_\n    return scalar_mult.join(P._repr_generator(g) + exp(v) for g,v in monomial)\n  File \"/ext/sage/sage-9.2/local/lib/python3.8/site-packages/sage/monoids/indexed_free_monoid.py\", line 115, in <genexpr>\n    return scalar_mult.join(P._repr_generator(g) + exp(v) for g,v in monomial)\nValueError: not enough values to unpack (expected 2, got 1)\n"}︡{"done":true}
︠c06441de-b0a3-4771-b3a1-5d1a6705de5ds︠

Monoids().axioms()
︡bac4e8ba-921d-4bf0-b590-9bcf7fba2e05︡{"stdout":"frozenset({'Unital', 'Associative'})\n"}︡{"done":true}
︠644e0183-a6cc-4758-be32-82a11d6e6220i︠
%html
<h2>
    Abelian Groups
</h2>
︡50831257-bd53-416c-83ae-ff7cc5ee5cb3︡{"done":true,"html":"<h2>\n    Abelian Groups\n</h2>"}
︠cb0db29a-cdaf-4d24-b30a-215d3fa55ca1︠
%html
<p>
   Most standard algebraic stuctures are built into SageMath.  Some do require importing a packages such <c>abelian_grps</c>.
</p>
︡fda383a1-608e-47c2-baf5-fae2145aa177︡{"done":true,"html":"<p>\n   Most standard algebraic stuctures are built into SageMath.  Some do require importing a packages such <c>Group</c>.\n</p>"}
︠8939260e-7f2b-4e90-b30c-7c5e74357e1cs︠
from sage.groups.group import Group
︡179eebd7-5f7c-47f0-8c10-ec11de1139c1︡{"done":true}
︠f30d7b6d-7128-4450-a0db-603acf1fb699s︠
import sage.groups.abelian_gps

︡34fc7619-96ef-4b02-813c-c4e3590fad84︡{"done":true}
︠a378e453-2783-4cda-a61b-69d6e1949d84s︠
G=AbelianGroup([2,4])
G
︡56be6392-f3f7-447c-9d14-e94ee59007c4︡{"stdout":"Multiplicative Abelian group isomorphic to C2 x C4\n"}︡{"done":true}
︠e9fee7fa-9cad-4980-912a-145e6d93b488s︠
G
︡d9b315d3-5799-418b-b383-b429d23299b3︡{"stdout":"Multiplicative Abelian group isomorphic to C2 x C4\n"}︡{"done":true}
︠d94c9d79-1dee-4996-91dd-ba21f4feba02s︠
G.order?
︡e333c650-0804-425c-8621-cb8fac823620︡{"code":{"filename":null,"lineno":-1,"mode":"text/x-rst","source":"File: /ext/sage/9.5/local/var/lib/sage/venv-python3.9.9/lib/python3.9/site-packages/sage/groups/abelian_gps/abelian_group.py\nSignature : G.order(self)\nDocstring :\nReturn the order of this group.\n\nEXAMPLES:\n\n   sage: G = AbelianGroup(2,[2,3])\n   sage: G.order()\n   6\n   sage: G = AbelianGroup(3,[2,3,0])\n   sage: G.order()\n   +Infinity"}}︡{"done":true}
︠a12b0796-c0a3-470c-8858-c739e24a7be3︠
G.is_cyclic()
︡d88d3b3d-e85d-4608-9aa0-06f8fccee993︡{"stdout":"False\n"}︡{"done":true}︡
︠2121c924-7185-4b23-bd97-81f8d1751247︠
G.cayley_table(names='elements')
︡1a64c927-7a9c-47fc-abb7-ee04696423e6︡{"stdout":"      *        1      f1    f1^2    f1^3      f0   f0*f1 f0*f1^2 f0*f1^3\n       +----------------------------------------------------------------\n      1|       1      f1    f1^2    f1^3      f0   f0*f1 f0*f1^2 f0*f1^3\n     f1|      f1    f1^2    f1^3       1   f0*f1 f0*f1^2 f0*f1^3      f0\n   f1^2|    f1^2    f1^3       1      f1 f0*f1^2 f0*f1^3      f0   f0*f1\n   f1^3|    f1^3       1      f1    f1^2 f0*f1^3      f0   f0*f1 f0*f1^2\n     f0|      f0   f0*f1 f0*f1^2 f0*f1^3       1      f1    f1^2    f1^3\n  f0*f1|   f0*f1 f0*f1^2 f0*f1^3      f0      f1    f1^2    f1^3       1\nf0*f1^2| f0*f1^2 f0*f1^3      f0   f0*f1    f1^2    f1^3       1      f1\nf0*f1^3| f0*f1^3      f0   f0*f1 f0*f1^2    f1^3       1      f1    f1^2\n\n"}︡{"done":true}︡
︠81dd6538-1fc2-43cc-a38f-d03d557b535c︠
sage.groups.abelian_gps.abelian_group?
︡6e40ce90-12e3-412c-95e0-ec8d6982fc03︡
︠5085972b-b45f-49b2-8076-322c043af196︠

%html
<h2>
    Modular Arithmetic
</h2>
︡ac1d7317-a389-4e4f-951d-d9888d41d6e7︡{"done":true,"html":"<h2>\n    Modular Arithmetic\n</h2>"}
︠5111ba20-9f49-4ba7-a09f-e9c5baad314a︠

︡0c8b7a62-ab74-4d4c-ae5c-5f43ee04f8e0︡
︠f8133b3e-3834-4f9a-800a-ef34011e1114s︠
def U_table(n):
    if n.parent()!=2.parent() or n<2 or n>64:
        return "input error/out of range"
    R=Integers(n)
    els=[]
    for k in filter(lambda k:gcd(n,k)==1,range(n)):
        els=els+[str(k)]
    return R.multiplication_table(elements=els,names="elements")
︡c2068f94-d364-4832-8295-aac71f4eff6c︡{"done":true}
︠b0de7cdb-2554-4b16-8496-a4ddbfba252es︠
U_table(19)
︡20bc28be-1b41-4cb2-93d1-b607bcfade64︡{"stdout":" *   1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18\n  +------------------------------------------------------\n 1|  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18\n 2|  2  4  6  8 10 12 14 16 18  1  3  5  7  9 11 13 15 17\n 3|  3  6  9 12 15 18  2  5  8 11 14 17  1  4  7 10 13 16\n 4|  4  8 12 16  1  5  9 13 17  2  6 10 14 18  3  7 11 15\n 5|  5 10 15  1  6 11 16  2  7 12 17  3  8 13 18  4  9 14\n 6|  6 12 18  5 11 17  4 10 16  3  9 15  2  8 14  1  7 13\n 7|  7 14  2  9 16  4 11 18  6 13  1  8 15  3 10 17  5 12\n 8|  8 16  5 13  2 10 18  7 15  4 12  1  9 17  6 14  3 11\n 9|  9 18  8 17  7 16  6 15  5 14  4 13  3 12  2 11  1 10\n10| 10  1 11  2 12  3 13  4 14  5 15  6 16  7 17  8 18  9\n11| 11  3 14  6 17  9  1 12  4 15  7 18 10  2 13  5 16  8\n12| 12  5 17 10  3 15  8  1 13  6 18 11  4 16  9  2 14  7\n13| 13  7  1 14  8  2 15  9  3 16 10  4 17 11  5 18 12  6\n14| 14  9  4 18 13  8  3 17 12  7  2 16 11  6  1 15 10  5\n15| 15 11  7  3 18 14 10  6  2 17 13  9  5  1 16 12  8  4\n16| 16 13 10  7  4  1 17 14 11  8  5  2 18 15 12  9  6  3\n17| 17 15 13 11  9  7  5  3  1 18 16 14 12 10  8  6  4  2\n18| 18 17 16 15 14 13 12 11 10  9  8  7  6  5  4  3  2  1\n\n"}︡{"done":true}
︠04898d36-21d0-4287-ad3d-e093f7fc4c65s︠
els=[]
for k in filter(lambda k:gcd(12,k)==1,range(12)):
    els=els+[str(k)]
els
︡1686bb81-255b-466d-9367-0c418dad7186︡{"stdout":"['1', '5', '7', '11']\n"}︡{"done":true}
︠d7c83a82-5253-4268-b25b-afac6decd769s︠
Z5.multiplication_table?
︡3a2f44b0-2bf2-4460-b10a-b39db54e2dd0︡
︠54f0b424-55e0-47ff-8596-e2499094ef20s︠
Z5.multiplication_table(elements=els,names="elements")
︡a0c603eb-2246-435d-9034-60d7ef1672f4︡{"stdout":" *   1  5  7 11\n  +------------\n 1|  1  5  7 11\n 5|  5  1 11  7\n 7|  7 11  1  5\n11| 11  7  5  1\n\n"}︡{"done":true}
︠dd29373a-43e1-482b-bdd7-3ad5ac39ccdd︠
a=2017
b=561
[q,r]=[a//b,a%b]
[q,r]
︡4300f014-ea61-4b58-9b98-6ad4988bb3d0︡{"stdout":"[3, 334]\n"}︡{"done":true}
︠c255b5e5-a57d-4110-b8e2-32abd0e95d05︠
a=2017
b=561
print gcd(a,b)
print xgcd(a,b)
︡a32cf387-e4d4-41fe-b587-40e5da4ccc7d︡{"stdout":"1\n"}︡{"stdout":"(1, -173, 622)\n"}︡{"done":true}︡
︠8a35f63e-181e-424c-996a-e6d2f32f5ace︠

︡b5453eda-5e32-475b-8531-11021d00b653︡
︠f4606ede-9025-4795-af0d-3393c9284c4b︠
G=AbelianGroup(1,[14])
G.list()

︡2dce4388-8544-43e2-99a7-326f829abeb0︡{"stdout":"(1, f, f^2, f^3, f^4, f^5, f^6, f^7, f^8, f^9, f^10, f^11, f^12, f^13)\n"}︡{"done":true}︡
︠a9ed0578-4e1c-41ed-b9e5-9360f3756b9b︠

for g in G:
    print str(g)+" has order "+str(g.order())
︡df02ccfb-a961-4b8b-b450-c71d02e5988b︡{"stdout":"1 has order 1\nf has order 14\nf^2 has order 7\nf^3 has order 14\nf^4 has order 7\nf^5 has order 14\nf^6 has order 7\nf^7 has order 2\nf^8 has order 7\nf^9 has order 14\nf^10 has order 7\nf^11 has order 14\nf^12 has order 7\nf^13 has order 14\n"}︡{"done":true}︡
︠4d9fd043-fbbf-447c-aaf8-eb367e7c399e︠
G= AdditiveAbelianGroup([2,2,2])
G.list()
︡bada4798-f41a-4f6d-8671-8f612efbab06︡{"stdout":"[(0, 0, 0), (1, 0, 0), (0, 1, 0), (1, 1, 0), (0, 0, 1), (1, 0, 1), (0, 1, 1), (1, 1, 1)]\n"}︡{"done":true}︡
︠b70f89f0-6141-499c-8082-375b35b33f8f︠

︡1f754fe6-67af-46cb-b714-74624186270e︡
︠a221236b-8467-4ab7-909f-d6be847d0f68︠
G.is_cyclic()
︡1826e3d7-8447-444b-8368-6e78e189cce7︡{"stdout":"False\n"}︡{"done":true}︡
︠1cba1acb-2828-48e0-8d00-0cf900e05922︠
 G= AdditiveAbelianGroup([23]); G
︡a362baa5-d9c0-4952-85ec-1aa29360f1d3︡{"stdout":"Additive abelian group isomorphic to Z/23\n"}︡{"done":true}︡
︠1ee6efd6-3c4c-4bc8-a2ad-7bad2bf28b27︠
G2=AdditiveAbelianGroup([2,4]);G2
︡4c57e1e4-fedf-48ad-8ec7-a1143cdaf042︡{"stdout":"Additive abelian group isomorphic to Z/2 + Z/4\n"}︡{"done":true}︡
︠c018ae9f-e695-4ab0-9976-05083763013c︠

G2.addition_table(names='elements')
︡b0a6f819-f2ba-4cf3-bbe4-f96a302a5f6c︡{"stdout":"     +  (0, 0) (0, 1) (0, 2) (0, 3) (1, 0) (1, 1) (1, 2) (1, 3)\n      +--------------------------------------------------------\n(0, 0)| (0, 0) (0, 1) (0, 2) (0, 3) (1, 0) (1, 1) (1, 2) (1, 3)\n(0, 1)| (0, 1) (0, 2) (0, 3) (0, 0) (1, 1) (1, 2) (1, 3) (1, 0)\n(0, 2)| (0, 2) (0, 3) (0, 0) (0, 1) (1, 2) (1, 3) (1, 0) (1, 1)\n(0, 3)| (0, 3) (0, 0) (0, 1) (0, 2) (1, 3) (1, 0) (1, 1) (1, 2)\n(1, 0)| (1, 0) (1, 1) (1, 2) (1, 3) (0, 0) (0, 1) (0, 2) (0, 3)\n(1, 1)| (1, 1) (1, 2) (1, 3) (1, 0) (0, 1) (0, 2) (0, 3) (0, 0)\n(1, 2)| (1, 2) (1, 3) (1, 0) (1, 1) (0, 2) (0, 3) (0, 0) (0, 1)\n(1, 3)| (1, 3) (1, 0) (1, 1) (1, 2) (0, 3) (0, 0) (0, 1) (0, 2)\n\n"}︡{"done":true}︡
︠7b6ba549-8f52-4139-96c7-21cf9136740b︠

︡3428346e-36b0-4674-8bc5-6d2b09e86a29︡
︠ddca6066-9545-48b0-aae3-2e6c413db2e9︠
G2.is_cyclic()

︡d123429e-96ca-40fc-9f95-c6f80ba905bf︡{"stdout":"False\n"}︡{"done":true}︡
︠9caf6807-60ca-45b2-b565-c9a9759e38fe︠
a=[1878,1384,84,2021,784,1509,1740,1201,2363,1774,1865,33,1477,894,690,520,198,1349,1278,650]
s =0
for t in a:
    s+=t
s
︡92571365-7a25-4e02-bf21-349c33ff3f30︡{"stdout":"23692\n"}︡{"done":true}︡
︠bab604f5-7dde-4062-b3f7-018343fd3649︠

︡d78c4e61-7c25-4cf3-a29b-5e771f7ef66d︡
︠0787882d-0a36-42b1-b75f-3852538bac7e︠
G=cartesian_product([Integers(32),Integers(27),Integers(25)])
def theta(x):
    return G((x%32,x%27,x%25))
︡01978c6d-c92a-4aae-9f2a-29c170c1c495︡{"done":true}︡
︠3372f9c6-1278-4535-8244-672d4de7ddb4︠
theta(1000)
︡049d7cfa-e923-4386-8d11-e31ac903c78d︡{"stdout":"(8, 1, 0)\n"}︡{"done":true}︡
︠67c2c1a7-b830-4fee-8542-f336d09360f2︠
[theta(1878)+theta(1384),theta(1878+1384)]
︡3c07c46c-0200-47d2-9663-b1901ddf0996︡{"stdout":"[(30, 22, 12), (30, 22, 12)]\n"}︡{"done":true}︡
︠d5141ac6-0fc6-47f8-a7d5-9f33d2ebc57f︠
sum=G((0,0,0))
for t in a:
    sum+=theta(t)
sum
︡e46eded7-ae28-4345-b316-d6e1d5543b3d︡{"stdout":"(12, 13, 17)\n"}︡{"done":true}︡
︠627e5e22-9710-4447-af24-1347adde0943︠
l=list(sum)
︡5036c26c-6290-443a-9ced-2c61eaa648ef︡{"done":true}︡
︠52374f8c-d1dd-4373-8298-a1ffde9cb941︠
(7425*12 + 6400*13+ 7776* 17)%21600
︡86c7befc-01d8-4a64-a250-87f4ca2df6a1︡{"stdout":"2092\n"}︡{"done":true}︡
︠fed94cfe-c8db-43e2-8b6d-ed0bbb8ddbcb︠
isum=crt([12,13,17],[32,27,25])
[isum,(s-isum)%(32*27*25)]

︡43718fda-7fc9-428b-a10b-65ee60a8320b︡{"stdout":"[2092, 0]\n"}︡{"done":true}
︠329c39dc-91d9-450d-a522-9d89c027471f︠
32*27*25
︡c5fb24eb-d854-4a6b-9899-5fb11cda0801︡︡{"stdout":"21600\n"}︡{"done":true}︡
︠79f4a6e8-55fd-4017-a134-a51516d4e8a6︠
s =0
for t in a:
    s+=t
s
︡ed3d6b80-b9e7-4425-aa55-103ae0de5fe4︡
︠66469108-d75c-4859-959f-52436a0fd59a︠
(s-isum)%21600
︡28e47bec-5f31-42a3-99e6-8a20db7fe793︡{"stdout":"0\n"}︡{"done":true}︡
︠7993cfbe-1d3f-4153-ab44-b77aaae4e7ca︠
u=[crt([1,0,0],[32,27,25]),crt([0,1,0],[32,27,25]),crt([0,0,1],[32,27,25])]
u

︡b4404ff2-1628-482b-8901-3fe999824b81︡{"stdout":"[7425, 6400, 7776]\n"}︡{"done":true}︡
︠6a146018-5d16-4822-97d0-f6e55903c214︠
G=DihedralGroup(5)
gr=G.cayley_graph(simple="True")
gr.plot(vertex_size=2)

︡6ae9f61e-4a88-4d29-a8e6-eb27497646e9︡{"file":{"filename":"/home/user/.sage/temp/project-f351622c-d261-4717-abee-4c0bfa210e88/8408/tmp_X89bih.svg","show":true,"text":null,"uuid":"8659fffa-515f-45b4-9121-5dbbf6da968a"},"once":false}︡{"done":true}︡
︠c97e73f1-93ed-450d-bdcf-0bca166b879b︠

︡d4bc1703-f8f5-4576-9a83-3dcfff39d56f︡
︠581638d1-1936-443d-aefd-694eaac556cb︠

︡02aafa97-bc49-40b8-8ee3-05da4edb83c4︡{"done":true}︡
︠2cbdc771-6f01-4418-b320-38586c30a081︠

︡d02a9902-7533-4ea4-8433-920358febe5a︡{"file":{"filename":"/projects/f351622c-d261-4717-abee-4c0bfa210e88/.sage/temp/compute4-us/28031/tmp_u0APcf.svg","show":true,"text":null,"uuid":"58735ce5-09b5-413a-9980-86a7fedb3921"},"once":false}︡{"done":true}︡
︠8fb59f30-1c1b-41dd-8cc7-94f574e562a9︠

g=DiGraph({2:[1],1:[2,3]})
g.plot()
︡b36fe1b8-336e-4f43-acf8-32e75795c7fd︡{"file":{"filename":"/home/user/.sage/temp/project-f351622c-d261-4717-abee-4c0bfa210e88/8408/tmp_A_jf9K.svg","show":true,"text":null,"uuid":"c604d8ae-bdc4-409b-92c0-f7d554f6e707"},"once":false}︡{"done":true}︡
︠b4f72906-905f-4db4-8ecf-212f1eae724b︠
triangle = SymmetricGroup(3)
triangle.list()
︡a208ac5f-0ce1-42c9-b308-2d9f3b1219da︡{"stdout":"[(), (1,2), (1,2,3), (1,3,2), (2,3), (1,3)]"}︡{"stdout":"\n"}︡{"done":true}︡
︠d7b704c6-0c89-4a5a-a63a-6eae52cc1fcc︠
triangle.cayley_graph(generators=[(1,2),(1,2,3)]).show()
︡252b6602-0b4f-48d2-b476-6ec1a3038b22︡{"file":{"filename":"/projects/f351622c-d261-4717-abee-4c0bfa210e88/.sage/temp/compute4-us/19527/tmp_8ymeWq.svg","show":true,"text":null,"uuid":"1e533f46-e8ca-47a9-bbc8-d8d082e626e0"},"once":false}︡{"done":true}︡
︠f2571865-5ab0-4b7e-adf8-bffc4d911a79︠
triangle.cayley_graph(generators=[(1,2),(1,3)]).show()
︡d9658095-f033-474a-954d-64ca5385dc1c︡{"file":{"filename":"/projects/f351622c-d261-4717-abee-4c0bfa210e88/.sage/temp/compute4-us/19527/tmp_K7N6Ce.svg","show":true,"text":null,"uuid":"caae7b87-ae36-4154-a1bb-4024b30089c5"},"once":false}︡{"done":true}︡
︠8e278307-b96f-4e8c-961c-9868542f8952s︠
G=DihedralGroup(4)
︡f7714ffa-7011-4111-a7b3-12f861e3d7ea︡{"done":true}
︠b6cbe93d-93a7-4665-b57b-625cfaada10bs︠
G.cayley_table()
︡e801b913-c623-40d7-9d5d-64bf586b5352︡{"stdout":"*  a b c d e f g h\n +----------------\na| a b c d e f g h\nb| b a d c f e h g\nc| c g a e d h b f\nd| d h b f c g a e\ne| e f g h a b c d\nf| f e h g b a d c\ng| g c e a h d f b\nh| h d f b g c e a\n"}︡{"stdout":"\n"}︡{"done":true}︡
︠fce0dee6-8ae3-447e-9a30-89d9b8a7eeb9s︠
G.list()
︡ac859d9f-52d7-42fd-87c0-f7fd07fd6fb5︡{"stdout":"[(), (1,5,4,3,2), (1,4,2,5,3), (1,3,5,2,4), (1,2,3,4,5), (2,5)(3,4), (1,5)(2,4), (1,4)(2,3), (1,3)(4,5), (1,2)(3,5)]\n"}︡{"done":true}︡
︠db578935-95b7-42e9-ab62-e38111fbd5d0︠
22









